﻿/* Edsger Dijkstra: "Einfachheit ist Voraussetzung für Zuverlässigkeit." */

;var dl = (function (doc) {
  "use strict"; // doc = el.ownerDocument; doc = window.document;  win = doc.defaultView; url = doc.URL; /*win.location.href*/

var win = doc.defaultView;
var menu_url;
var dls = {
liste: { dl: 0, dt: [], dd: [], aktiv: { dd: "block", dt: "dt_aktiv" }, passiv: { dd: "none", dt: "dt_passiv"} },
list: { dl: 0, dt: [], dd: [], aktiv: { dd: "block", dt: "dt_aktiv" }, passiv: { dd: "none", dt: "dt_passiv"} },
app: { dl: 0, dt: [], dd: [], aktiv: { dd: "block", dt: "dt_aktiv" }, passiv: { dd: "none", dt: "dt_passiv"} },
menu: { dl: 0, dt: [], dd: [], aktiv: { dd: "block", dt: "dt_aktiv" }, passiv: { dd: "none", dt: "dt_passiv"} },
/* demnächst:
liste: { dl: 0, dt: [], dd: [],
aktiv:  { dt: "dt_aktiv",  dd: "visible", dd_className: "visibility:visible;opacity:1;" },
passiv: { dt: "dt_passiv", dd: "hidden", dd_className: "background-color:rgba(92,90,90,0.9);position:absolute;opacity:0.5;visibility:hidden;transition:opacity 900ms,visibility 900ms;" }
},
*/
version: 0.9
};

function offset(el) { //var left = el.offsetWidth / 2, top = el.offsetHeight / 2;
var width = el.offsetWidth, height = el.offsetHeight, left = 0, top = 0;
while (el && el.nodeType === 1) {
  left += el.offsetLeft;
  top += el.offsetTop;
  el = el.offsetParent;
} return [left, top, width, height];
}

function is_mobil() { var r = false; 
if (top && top.document) { r = (top.document.getElementsByTagName("frame").length === 1);
} return r;
}

function is_menu_seite() { var r = false, s = -1; // merke global menu_url
if (is_mobil()) { s = top.document.getElementById("FRAME_INFO").src;
r = /menu\.htm/.test(s); if (r) { menu_url = s; } 
} return r;
}

function set_mobil_style() {// für menu.htm-Seite, verwendet dort "STYLE_MOBIL" statt "STYLE_PC" 
var h1 = document.getElementsByTagName("h1")[0],
style_pc = document.getElementById("STYLE_PC"),
style_mobil = document.getElementById("STYLE_MOBIL");
if (is_menu_seite() && style_pc && style_mobil) { style_pc.innerHTML = "";
  style_mobil.innerHTML = style_mobil.innerHTML.replace(/\/\*([\s\S]+)\*\//g, "$1");
} else if (is_mobil()) { h1.innerHTML = '<a id="back_link" class="button" target="FRAME_INFO" href="' + menu_url + '"> ≡ </a>' + h1.innerHTML;
}
}



function get_dt_dd_nodes(that) { //return {dl_node:, dl_className:, dt_nodes:, dd_nodes:, aktTagName:, aktIdx:}
var i, temp, r = {}, dl = that;
while (typeof dl === "object" && dl.tagName.toUpperCase() !== "DL" && dl.parentNode) {
  dl = dl.parentNode;
  if (dl.tagName.toUpperCase() === "DD") { r.aktTagName = "DD"; that = dl; }
  if (dl.tagName.toUpperCase() === "DT") { r.aktTagName = "DT"; that = dl; }
} if (typeof dl !== "object") { return r; }
r.dl_node = dl; r.dl_className = dl.className;
r.dt_nodes = dl.querySelectorAll("dt");
r.dd_nodes = dl.querySelectorAll("dd");

temp = r.dt_nodes; if (r.aktTagName === "DD") { temp = r.dd_nodes; }
for (i = 0; i < temp.length; i += 1) {
  if (temp[i] === that) { r.aktIdx = i; break; }
}
//alert(r.dl_node + " " + r.dt_nodes + " " + r.dd_nodes + " " + r.dl_className + " " + r.aktIdx + " " + r.aktTagName);
return r;
}

function set_dt_style(k, cls, visi) {
var o = dls[cls];
if (k >= 0 && k < o.dt.length) {
  // o.dd[k].setAttribute("data-idx", "dd-" + k);
  // o.dt[k].setAttribute("data-idx", "dt-" + k);
  o.dd[k].style.display = o[visi].dd;
  o.dt[k].className = o[visi].dt;
  o.dt[k].style.cursor = "pointer";
}
}

function toggle_all_dd(cls, mod) { //  mod = "passiv" | "aktiv" | "toggle" | [0,2,3]
var j, k, len = -1, a = ["passiv", "aktiv"];
if (!mod) { alert('ERR: toggle_all_dd(...,mod=??? "passiv"|"aktiv"|"toggle"'); }

if (typeof mod === "string") {
  switch (mod) {
    case "passiv": k = 0; break; // verberge alle dd  
    case "aktiv": k = 1; break;  // zeige    alle dd 
    case "toggle": k = (1 + dls[cls].mod) % 2; break; // toggle alle dd        
    default: alert('ERR: toggle_all_dd(...,mod=??? "passiv"|"aktiv"|"toggle"');
  } dls[cls].mod = k;

  for (j = 0; j < dls[cls].dd.length; j += 1) {
    //dls[cls].dd[j].style.display = dls[cls][visi].dd;
    //dls[cls].dt[j].className = dls[cls][visi].dt;
    set_dt_style(j, cls, a[k]);
  }
} else if (Array.isArray(mod)) {
  k = 0; for (j = 0; j < dls[cls].dd.length; j += 1) { set_dt_style(j, cls, a[k]); }
  k = 1; for (j = 0; j < mod.length; j += 1) { set_dt_style(mod[j], cls, a[k]); }
}
}

//akkordeon initialisieren unter window.onload
function css_class(cls, mod) { //cls = cls, d.h. dl-Tag mit class="cls"
// cn = "className" des dl-Tags //default: dl entspricht dl class="liste"

var len; if (!mod) { mod = []; }
dls[cls].mod = mod;
dls[cls].displ = "display"; //if (cls === "karussell" || cls === "XXX list") { dls[cls].displ = "visibility"; }

function dt_handler(dls, i) { // aktueller dt Handler zur Laufzeit
  return function (event) {
    var jj; var aktiv;

    if (!(dls && dls[cls] && dls[cls].dt && dls[cls].dd && dls[cls].dt[i] && dls[cls].dd[i])) {
      win.alert("ERR: dt_handler(dls, i) hat Closure-Fehler beim Zugriff auf Elemente von dls"); return;
    }

    if (dls[cls].dt.length !== dls[cls].dd.length) {
      win.alert("ERR: dl_class(\"" + cls + "\") mit dt.length=" + dls[cls].dt.length + " und dd.length=" + dls[cls].dd.length);
    }

    if (event.target.tagName.toUpperCase() === "A") {
      if (event.target.parentNode.tagName.toUpperCase() === "DT") {
        // callback(get_node_idx_of( el ))
        event.preventDefault(); event.stopPropagation(); return;
      } toggle_all_dd(dls[cls], dls[cls].mod); return;
    }

    for (jj = 0; jj < dls[cls].dt.length; jj += 1) {
      if (dls[cls].dd[jj]["style"][dls[cls].displ] === dls[cls].aktiv.dd) { aktiv = jj; }
      dls[cls].dd[jj]["style"][dls[cls].displ] = dls[cls].passiv.dd;
      dls[cls].dt[jj].className = dls[cls].passiv.dt;
    }
    if (i !== aktiv) {
      dls[cls].dd[i]["style"][dls[cls].displ] = dls[cls].aktiv.dd;
      dls[cls].dt[i].className = dls[cls].aktiv.dt;
      //alert(i+ "(=i !== aktiv): " + dls[cls].displ+" "+dls[cls].aktiv.dd + "  " + dls[cls].aktiv.dt);
    }
    // (function (ev) { ev.preventDefault(); ev.stopPropagation(); })(event);
  };
}

dls[cls].dl = doc.querySelectorAll("dl." + cls);
dls[cls].dt = doc.querySelectorAll("dl." + cls + ">dt");
dls[cls].dd = doc.querySelectorAll("dl." + cls + ">dd");
//if (dls[cls].dl.length === 0) {win.alert("ERR: kein Tag dl." + cls + " vorhanden"); return; }

var kk = dls[cls].dt.length; // Math.min(dls[cls].dt.length, dls[cls].dd.length);
var j = kk;

while (j > 0) {
  j -= 1;
  if (!dls[cls].dt[j].onclick) { // init  dt-click-handler
    dls[cls].dt[j].addEventListener("click", dt_handler(dls, j), false);
    set_dt_style(j, cls, "passiv");
  }
}

//j = mod; if (typeof j === "number" && j >= 0 && j < kk) { set_dt_style(j, cls, "aktiv"); }

len = -1; if (typeof mod === "object") { len = dls[cls].mod.length; }
if (len >= 0) {
  for (j = 0; j < len; j += 1) { set_dt_style(j, cls, "aktiv"); }
  set_mobil_style();
}
}


return { offset: offset, //scroll_into_view: scroll_into_view,
get_dt_dd_nodes: get_dt_dd_nodes,
toggle_all_dd: toggle_all_dd,
css_class: css_class,

version: 2017
};
} (document));
