﻿;var nav = (function (doc) {
    "use strict"; // doc = el.ownerDocument; doc = window.document;  win = doc.defaultView; url = doc.URL; /*win.location.href*/

    var win = doc.defaultView;
    var dls = {
        liste: { dl: 0, dt: [], dd: [], dt_collapse: 0, aktiv: { dd: "block", dt: "dt_aktiv" }, passiv: { dd: "none", dt: "dt_passiv"} },
        menu: { dl: 0, dt: [], dd: [], dt_collapse: 0, aktiv: { dd: "block", dt: "dt_aktiv" }, passiv: { dd: "none", dt: "dt_passiv"} },
        dt_dd_rows: { dl: 0, dt: [], dd: [], dt_collapse: 0, aktiv: { dd: "block", dt: "dt_aktiv" }, passiv: { dd: "none", dt: "dt_passiv"} },
        dt_dd_cells: { dl: 0, dt: [], dd: [], dt_collapse: 0, aktiv: { dd: "block", dt: "dt_aktiv" }, passiv: { dd: "none", dt: "dt_passiv"} }
    };

    function set_dt_style(k, cls, visi) {
        dls[cls].dd[k].style.display = dls[cls][visi].dd;
        dls[cls].dt[k].className = dls[cls][visi].dt;
    }

    function toggle_all_dd(cls, dt_collapse, i) {
        // dl-Tag hat class="cls"; 1=dt_collapse=show-all; 0=dt_collapse=hide-all; 3=i zeigt dd[3]
        var j; var k; var visi = "passiv";
        switch (dt_collapse) {
            case 1: k = 1; break; // zeige    alle dd 
            case 0: k = 0; break; // verberge alle dd  
            default: k = (1 + dls[cls].dt_collapse) % 2; // zeige/verberge alle dd (togglen)
        }
        if (k === 1) { visi = "aktiv"; } else { visi = "passiv"; }

        for (j = 0; j < dls[cls].dd.length; j += 1) {
            //dls[cls].dd[j].style.display = dls[cls][visi].dd;
            //dls[cls].dt[j].className = dls[cls][visi].dt;
            set_dt_style(j, cls, visi);
        } dls[cls].dt_collapse = k;

        if (typeof i === "number" && i >= 0 && i < dls[cls].dt.length) { set_dt_style(i, cls, "aktiv"); }

        // experimente mit ...
        //            if (event.target.tagName.toUpperCase() === "A") { // z.B. a-Tag im dt-tag
        //                (function (ev) { ev.preventDefault(); ev.stopPropagation(); })(event);
        //                //event.preventDefault(); event.stopPropagation();
        //                return;
        //            }

    }


    //akkordeon initialisieren unter window.onload
    function dl_class(cls, idx_nach_laden_sichtbar) { //cls = cls, d.h. dl-Tag mit class="cls"
        // cn = "className" des dl-Tags //default: dl entspricht dl class="liste"

        function dt_handler(dls, i) { // aktueller dt Handler zur Laufzeit
            return function (event) {
                var jj; var aktiv;
                if (!(dls && dls[cls] && dls[cls].dt && dls[cls].dd && dls[cls].dt[i] && dls[cls].dd[i])) {
                    win.alert("ERR: dt_handler(dls, i) hat Closure-Fehler beim Zugriff auf Elemente von dls"); return;
                }

                if (dls[cls].dt.length !== dls[cls].dd.length) {
                    win.alert("ERR: dl_class(\"" + cls + "\") mit dt.length=" + dls[cls].dt.length + " und dd.length=" + dls[cls].dd.length);
                }

                if (event.target.tagName.toUpperCase() === "A") { toggle_all_dd(dls[cls], dls[cls].dt_collapse); return; }

                for (jj = 0; jj < dls[cls].dt.length; jj += 1) {
                    if (dls[cls].dd[jj].style.display === dls[cls].aktiv.dd) { aktiv = jj; }
                    dls[cls].dd[jj].style.display = dls[cls].passiv.dd;
                    dls[cls].dt[jj].className = dls[cls].passiv.dt;
                }    // liste: { aktiv: { dd: "block", dt: 1 }, passiv: { dd: "none", dt: 0} },
                if (i !== aktiv) {
                    //alert("(i !== aktiv): " + dls[cls].aktiv.dd + "  " + dls[cls].aktiv.dt);
                    dls[cls].dd[i].style.display = dls[cls].aktiv.dd;
                    dls[cls].dt[i].className = dls[cls].aktiv.dt;
                } // (function (ev) { ev.preventDefault(); ev.stopPropagation(); })(event);
            };
        }

        dls[cls].dl = doc.querySelectorAll("dl." + cls);
        dls[cls].dt = doc.querySelectorAll("dl." + cls + ">dt");
        dls[cls].dd = doc.querySelectorAll("dl." + cls + ">dd");


        //dls[cls].dd[k].style.display = dls[cls][visi].dd;
        //dls[cls].dt[k].className = dls[cls][visi].dt;


        var kk = Math.min(dls[cls].dt.length, dls[cls].dd.length);
        var j = kk;
        while (j > 0) {
            j -= 1;
            if (!dls[cls].dt[j].onclick) { // init  dt-click-handler
                dls[cls].dt[j].addEventListener("click", dt_handler(dls, j), false);
                set_dt_style(j, cls, "passiv");
            }
        }
        if (cls === "menu" || cls === "liste") {
            j = idx_nach_laden_sichtbar;
            if (typeof j === "number" && j >= 0 && j < kk) { set_dt_style(j, cls, "aktiv"); }
        }
    }
    return { dl_class: dl_class, toggle_all_dd: toggle_all_dd };
} (document));


// document.addEventListener("DOMContentLoaded", function (event) { "use strict"; nav.dl_class("liste"); });
// alternativ 
// window.addEventListener("load", function (event) { "use strict"; nav.dl_class("liste", -1); }, true);

